/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import URI from '@devpodio/core/lib/common/uri';
import { BaseLanguageClientContribution, Workspace, Languages, LanguageClientFactory, ILanguageClient } from '@devpodio/languages/lib/browser';
import { TypeScriptInitializationOptions } from 'typescript-language-server/lib/ts-protocol';
import { TypescriptPreferences } from './typescript-preferences';
export declare class TypeScriptClientContribution extends BaseLanguageClientContribution {
    protected readonly workspace: Workspace;
    protected readonly languages: Languages;
    protected readonly languageClientFactory: LanguageClientFactory;
    readonly id: string;
    readonly name: string;
    protected readonly preferences: TypescriptPreferences;
    constructor(workspace: Workspace, languages: Languages, languageClientFactory: LanguageClientFactory);
    protected init(): void;
    protected readonly documentSelector: string[];
    protected readonly workspaceContains: string[];
    protected readonly initializationOptions: Partial<TypeScriptInitializationOptions>;
    protected _logFileUri: URI | undefined;
    readonly logFileUri: URI | undefined;
    protected onReady(languageClient: ILanguageClient): void;
}
//# sourceMappingURL=typescript-client-contribution.d.ts.map