/********************************************************************************
 * Copyright (C) 2018 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import * as tsp from 'typescript/lib/protocol';
import { QuickPickService, KeybindingRegistry, KeybindingContribution } from '@devpodio/core/lib/browser';
import { EditorManager, EditorWidget } from '@devpodio/editor/lib/browser';
import { CommandContribution, CommandRegistry, Command, MenuModelRegistry, MenuContribution } from '@devpodio/core/lib/common';
import { TypeScriptClientContribution } from './typescript-client-contribution';
import { FileSystemWatcher, FileMoveEvent } from '@devpodio/filesystem/lib/browser';
export declare namespace TypeScriptCommands {
    const applyCompletionCodeAction: Command;
    const organizeImports: Command;
    const openServerLog: Command;
}
export declare class TypeScriptFrontendContribution implements CommandContribution, MenuContribution, KeybindingContribution {
    protected readonly editorManager: EditorManager;
    protected readonly quickPickService: QuickPickService;
    protected readonly clientContribution: TypeScriptClientContribution;
    protected readonly fileSystemWatcher: FileSystemWatcher;
    protected init(): void;
    registerCommands(commands: CommandRegistry): void;
    registerMenus(menus: MenuModelRegistry): void;
    registerKeybindings(keybindings: KeybindingRegistry): void;
    openServerLog(): void;
    organizeImports(): void;
    readonly currentEditor: EditorWidget | undefined;
    protected pickCodeAction(codeActions: tsp.CodeAction[]): Promise<tsp.CodeAction | undefined>;
    protected applyCodeAction(codeAction: tsp.CodeAction): Promise<any>;
    protected renameFile({ sourceUri, targetUri }: FileMoveEvent): Promise<void>;
}
//# sourceMappingURL=typescript-frontend-contribution.d.ts.map